#include "mex.h"
#include "csources/svm.h"
#include "csources/svm_utils.h"
#include "csources/svm_params.h"
#include "csources/utils.h"

#include <cstring>

using namespace std;

void mexFunction( int nlhs, mxArray *plhs[],
             int nrhs, const mxArray *prhs[] )
{
	int i=0;

	if ((nlhs == 2) && (nrhs == 0)) {
		SVMconfig* config = new SVMconfig();

		double* lparams = double_array(PARAM_COUNT);
		config->get(lparams, PARAM_COUNT);

		char** param_ident = config->ident();

		MIndex dims = PARAM_COUNT;
		mxArray* mx_param_ident = mxCreateCellArray(1, &dims);

		for (i=0; i < PARAM_COUNT; i++) mxSetCell(mx_param_ident, i,  mxCreateString(param_ident[i]));	
		
		mxArray* mx_param = mxCreateNumericMatrix (1, PARAM_COUNT, mxDOUBLE_CLASS, mxREAL);
		memcpy(mxGetPr(mx_param) , lparams, PARAM_COUNT * sizeof(double));

		plhs[0] = mx_param_ident;	
		plhs[1] = mx_param;

		delete config;
		free_array(lparams);
	}
	else {
		mexPrintf ("Wrong number of input/output parameters (%i/%i). \n", nrhs, nlhs);
		for (i=0; i < nlhs; i++) plhs[i] = NULL;
	}
}
