%function HF = aplot_line (w,b,X,)
%function HF = aplot_line (w,b,X,col)
%function HF = aplot_line (w,b,X,col,hf)
% Diese Funktion arbeitet im Prinzip wie plot_line jedoch findet sie den Bereich in dem 
% die Ebene gemalt werden muss selbst.
% Eingabe:
%   w : Normalenvektor der Ebene
%   b : Threshold
%   X : Trainingsvektoren
%   col : Farb- und Formparameter fuer plot (optional)
%   hf : Handle des figure-Objektes in das gemalt werden soll (optional)
% Ausgabe:
%   HF : Handle des figure-Objektes in das gemalt wurde
function HF = aplot_line (w,b,X,col,hf),

     wn = -w(1)/w(2);
     bn = -b/w(2);
        
    xmin = min (X(1,:));
    xmax = max (X(1,:));
    
    ymin = min (X(2,:));
    ymax = max (X(2,:));
       
    if wn < 0,
        if wn*xmin + bn > ymax,
            x1 = (ymax - bn) / wn;
        else
            x1 = xmin;
        end;
        
        if wn*xmax + bn < ymin,
            x2 = (ymin - bn) / wn;
        else
            x2 = xmax;
        end
    else
        if wn*xmin + bn < ymin,
            x1 = (ymin - bn) / wn;
        else
            x1 = xmin;
        end;
        
        if wn*xmax + bn > ymax,
            x2 = (ymax - bn) / wn;
        else
            x2 = xmax;
        end
    end

    if (nargin > 3),
        if (nargin > 4),
            HF = plot_line (w,b,x1,x2,col,hf);
        else
            HF = plot_line (w,b,x1,x2,col);
        end
    else
        HF = plot_line (w,b,x1,x2);
    end
    
return;