#ifndef __CROSS_VALIDATION_H_INCLUDED__
#define __CROSS_VALIDATION_H_INCLUDED__

#include "grid_search.h"

#include <pthread.h>

#include <stack>

class ClassInfoDataDesc;
class Kernel;
class SVMconfig;
class HashConfig;
class InfoConfig;
class SubsetClassInfoDataDesc;

class CrossValidation : public TargetFunc {
public:

	CrossValidation(int k, ClassInfoDataDesc* data, const char** param_names, int nparams, Kernel* kernel,
			SVMconfig* config, HashConfig* hconfig, InfoConfig* iconfig);

	virtual ~CrossValidation (void);

	virtual void eval (double* x, double* y);

	virtual SubsetClassInfoDataDesc* GetBalancedSet (void);

	virtual int Dims(void) { return 2; }

private:
	ClassInfoDataDesc* data;
	SubsetClassInfoDataDesc** train_subsets;
	SubsetClassInfoDataDesc** test_subsets;
	int k;

	SubsetClassInfoDataDesc* balanced_set;

	const char** param_names;
	int nparams;

	Kernel* kernel;
	SVMconfig* config;
	HashConfig* hconfig;
	InfoConfig* iconfig;
};

#if 0
class ValidationThread {
	ValidationThread (SubsetClassInfoDataDesc* tr, SubsetClassInfoDataDesc* te, 
			  SVMconfig* config, HashConfig* hconfig, InfoConfig* iconfig) : config(config), hconfig(hconfig), iconfig(iconfig), test(te), train(tr) {

		counter++;
	}

	virtual ~ValidationThread (void) {
	}


	static Wait(void) {
	}

	void Start(void) {
		pthread_create();
	}

private:

	static void thread_run(void* param) {
		ValidationThread* thread = (ValidationThread*) param;
		param->Run();
	}

	void Run(void) {
		
		/* 
		.
		.
		.
		*/

		DecreaseCounter();
		if (counter == 0) pthread_mutex_unlock(&mut_wait);
	}
	
	static void RunAll (void) {
		while (!all.empty()) {
		}
	}

	static int counter;
	static stack<ValidationThread*> all;

	SVMconfig*  config;
	HashConfig* hconfig;
	InfoConfig* iconfig;

	SubsetClassInfoDataDesc* train;
	SubsetClassInfoDataDesc* test;
};

#endif

#endif
