#ifndef __GRID_SEARCH_H_INCLUDED__
#define __GRID_SEARCH_H_INCLUDED__

class TargetFunc {
public:
	virtual void eval (double* x, double* y) = 0;

	virtual int Dims(void) = 0;
};

class GridSearch {
public:

	GridSearch(double* tmin, double* tmax, double* tcount, double* tstop_tol, double zoom_factor, int ndims, int max_level, TargetFunc* tf);

	virtual ~GridSearch(void);

	double* search(double* best);
private:

	void eval(double* x,  double* cur_min, double* cur_max, double* cur_count, int dim);

	int ndims;
	int max_level;
	double zoom_factor;

	double* min;
	double* max;
	double* count;
	double* stop_tol;

	double** f;
	double** X;
	int pos;

	TargetFunc* target_func;
	int n_of_evals;
};

#endif
