#ifndef __SVM_UTILS_H_INCLUDED__
#define __SVM_UTILS_H_INCLUDED__

class Kernel;
class SVMconfig;
class InfoConfig;
class ClassInfoDataDesc;

int forgetting_criterion (ClassInfoDataDesc* X, double* c, int time, double l, double R, 
			double xmax, double xmin, int* I, int I_length, int* J, int J_length, 
			Kernel* K, tCache* G_cache, double* temp, SVMconfig* config, double** info);

void learn (double* alpha, double* s, double* t, ClassInfoDataDesc* X, double* c, int k, int k_start, 
	   Kernel* K, tCache* S_cache, tCache* G_cache, int* CLI, int CLI_length,
	   double* t_min, double* t_max, int* Y_max, int* SI, int* LI, int LI_length, int* I, int* J,
	   double* temp, int* itemp, int* iadd, int* isub,
	   int* bucket, int bucket_size, SVMconfig* config);

void find_cand (double* alpha, double* t, int C, int* CLI, int CLI_length,
		double* r_xmin, double* r_xmax, int* r_I, int* r_I_length, int* r_J, int* r_J_length, 
		int* SI, int* LI, int LI_length, double* t_min, double* t_max, int* Y_max, double* temp, int* itemp, int* bucket, int bucket_size);

void calc_kernel_values (double* dest, int* I_add, int I_add_length, int* I_sub, int I_sub_length, 
			 ClassInfoDataDesc* X, double* c, Kernel* K, int time, tCache* G_cache, int* itemp);

void calc_sum_diff (int* dest_key, int* cur_key, int key_length, int* I_add, int* I_sub, int* I_add_length, int* I_sub_length);

double duality_gap (double C, double C2, Kernel* K, tCache* G_cache, double* t, double* s, 
		    int* IP, int IP_length, int* IN, int IN_length, 
		    ClassInfoDataDesc* X, double* c, double* alpha, int X_columns); 

#endif
