%function [HF]=display_example (D,c);
%function [HF]=display_example (D,c, SVs, svcolor);
%function [HF]=display_example (D,c, SVs, svcolor, hf);
%Anzeigen von mit lsep oder example bzw. iexample generierten Beispieldifferenz-
% vektormengen
% Eingabe:
%   D : Matrix mit den Differenzvektoren als Spalten
%   c : Klassenzugehoerigkeit der Differenzvektoren
%   SVs : Matrix mit den Supportvektoren (optional)
%   svcolor : Form und Farbparameter fuer die SVs (optional, default '*k')
%   hf : Handle auf das Bild in das geplottet werden soll (optional)
% Ausgabe:
%   HF : Handle des Plots in den gemalt wurde
function [HF]=display_example (D,c, SVs, svcolor, hf);

if nargin > 4,
    figure(hf);
    HF = hf;
else
    HF = figure;
    hold;
end

if (nargin < 3),
    SVs = [];
end

if (nargin < 4),
    svcolor = '*k';
end

color = {'+b', 'xr', '+g', 'xy', 'Oc'};

if (~isempty(D) & ~isempty(c)) ,
    
    cl = sort(unique(c));
    
    for i=1:length(cl),
        I = find(c == cl(i));
        
        disp(sprintf('%i : %s', cl(i), color{i}));
        
        plot (D(1,I), D(2,I), color{i});
    end
    
% 	%Indizes der einzelnen Klasse heraussuchen
%     IN = find (c == cl(1));
% 	IP = find (c == cl(2));
% 	
% 	% Klasse gleiche Person herausholen
% 	P = D(:,IP);
% 	% Klasse ungleiche Person herausholen
% 	N = D(:,IN);
% 	
% 	% Klasse ungleiche Person plotten
% 	plot (N(1,:), N(2,:), '+b');
% 	
% 	% Klasse gleiche Person plotten
% 	plot (P(1,:),P(2,:), 'xr');
end

if (~isempty(SVs)),
    % die Supportvektoren besonders markieren
    plot (SVs(1,:), SVs(2,:), svcolor);
end

return;