%function ret = lparam_get(name, lparams, mode),
% get learning parameter
%
%Input:
%   mode : 0 -> description if available , 1 -> value
function ret = lparam_get(name, lparams, mode),

ret = [];

if(nargin <= 2),
    mode = 0;
end

%------------

package = lparams{1};

[params, p_names, p_index, c_index, descriptions] = lparam_info(package);

if strcmp(name,'description'),
    
    ret = '';
    sep = '';
    
    for i=1:length(p_names),
        if p_index(i),
            if isempty(descriptions{i}),
                ret = sprintf ('%s %s %s: %d', ret, sep, p_names{i}, double(lparam_get(p_names{i}, lparams, 1)));
            else
                ret = sprintf ('%s %s %s: %s', ret, sep, p_names{i}, lparam_get(p_names{i}, lparams));
            end
        end
        sep ='| ';
    end
    
    return; 
end

%--------------

pos = find(strcmp(p_names, name));

if ~isempty(pos),
    desc = descriptions{pos};
    
    if ~mode,
        
        if p_index(pos),
            val = lparams{c_index(pos)}(p_index(pos));
        else
            val = lparams{c_index(pos)};
        end
        
        if ~isempty(desc),
            ret = desc{val + 1};
        else
            disp(sprintf('no description for parameter %s available.', name));
        end
            
    else
        if p_index(pos) ,
            ret = lparams{c_index(pos)}(p_index(pos));
        else
            ret = lparams{c_index(pos)};
        end
    end
        
else
    disp(sprintf('unknown parameter %s.', name));
end

return;
