%function [params, p_names, p_index, c_index, description] = lparam_info(package);
function [params, p_names, p_index, c_index, description] = lparam_info(package);

p0_names = {'package', 'learn_params', 'kernel_params'};
p0_index = [1,0,0];

if package == 1, %DMMO
    
    c0_index = [1,2,3];
    
    [p1_names, l1_params] = DefaultMaxMinOverParams;
    
    p1_index = [1:length(p1_names)];
    c1_index = 2*ones(1,length(p1_names));
    
    p2_names  = {'gamma','degree','k'};
    l2_params = [1,1];
    p2_index  = [1,1,2];
    c2_index  = [3,3,3];
    
    p_names = { p0_names{:}, p1_names{:}, p2_names{:} };
    p_index = [ p0_index   , p1_index   , p2_index];
    c_index = [ c0_index   , c1_index   , c2_index];
    
    description = cell(1,length(p_names));
    
    description{find(strcmp(p_names, 'kernel_type'))} = {'linear','rbf', 'polynom'};
    description{find(strcmp(p_names, 'svm_type'))}    = {[], 'nu', 'C2'};
    description{find(strcmp(p_names, 'forget_sv'))}   = {'off','on-std','on-tight', 'always'};
    description{find(strcmp(p_names, 'mc_strategy'))} = {'oaa', 'oao' };
    
    params = { package , l1_params, l2_params };
    
elseif package == 2, % OSU-SVM
    
    c0_index = [1,2,2];

%OSU-SVM 3.0    
    p1_names = {'kernel_type','degree', 'gamma', 'coefficient','C','cache_size','epsilon','svm_type','nu' ,'loss_toleration','shrinking'};
    l1_params = [       2     ,    3   ,    1   ,         0    , 1 ,     40     , 0.001,      0     ,0.5   , 0.1            ,     1    ];
 
%OSU-SVM 2.0
%    p1_names = {'kernel_type','degree', 'gamma', 'coefficient','C','cache_size','epsilon','svm_type','nu' ,'loss_toleration'};
%    l1_params = [       2     ,    3   ,    1   ,         0    , 1 ,     40     , 0.001,      0     ,0.5   , 0.1            ];

    p1_index = [1:length(p1_names)];
    c1_index = 2*ones(1,length(p1_names));
    
%    p2_names = {'verbose'};
%    l2_params = 1;
%    p2_index = [1];
%    c2_index = [3];
    
    p_names = { p0_names{:}, p1_names{:}};
    p_index = [ p0_index, p1_index];
    c_index = [ c0_index, c1_index];
    
    description = cell(1,length(p_names));
    
    description{find(strcmp(p_names, 'kernel_type'))} = {'linear','polynom', 'rbf', 'sigmoid'};
    description{find(strcmp(p_names, 'svm_type'))} = {'c-SVC','nu-SVC', 'one-class SVM', 'epsilon-SVR', 'nu-SVR'};
    
    params = { package , l1_params};
else
    disp (sprintf('unknown package %i.', package));
end

description{find(strcmp(p_names,'package'))} = {[], 'mo', 'osu'};

return;