%function HF = plot_line(w,b,xmin,xmax);
%function HF = plot_line(w,b,xmin,xmax, col);
%function HF = plot_line(w,b,xmin,xmax, col, hf);
% Eingabe:
%   w : Normalenvektor
%   b : Abstand vom Nullpunkt
%   [xmin, xmax] : Intervall in dem die Linie gemalt werden soll
%   col : Farbparameter fuer plot (siehe auch help plot, optional, default 'k')
%   hf : Handle des figure in das geplottet werden soll (optional)
% Ausgabe:
%   HF : Handle des figure in das geplottet wurde
function HF = plot_line(w,b,xmin,xmax, col, hf),

wn = -w(1)/w(2);
bn = -b/w(2);

ymin = wn*xmin + bn;
ymax = wn*xmax + bn;

if (nargin > 5),
    figure (hf);
    HF = hf;
else
    HF = figure;
end

if (nargin > 4),
    plot([xmin,xmax], [ymin,ymax], col);
else
    plot([xmin,xmax], [ymin,ymax], 'k');
end

return;
